// Author: Lech Duraj
// O(n^2)
#include <iostream>
#include <algorithm>
#include <queue>

using namespace std;

int gcd(int a, int b)
{
    if (a<b)
        return gcd(b,a);
    if (b==0)
        return a;
    return gcd(b,a%b);
}

long long sq(int x)
{
    return x*(long long)x;
}

int main()
{
    ios_base::sync_with_stdio(false);
    int TT;
    cin >> TT;
    while(TT--)
    {
        int n;
        cin >> n;
        vector<int> X(n),Y(n),R(n);
        vector<int> moving(n,false);
        for(int i=0; i<n; i++)
            cin >> X[i] >> Y[i] >> R[i];
        queue<int> Q;
        Q.push(0);
        moving[0] = 1;
        while(!Q.empty())
        {
            int u = Q.front();
            Q.pop();
            for(int i=0; i<n; i++)
                if (moving[i]==0 && sq(X[i]-X[u])+sq(Y[i]-Y[u])==sq(R[i]+R[u]))
                {
                    moving[i] = -moving[u];
                    Q.push(i);
                }
        }
        for(int i=0; i<n; i++)
        {
            if (moving[i]==0)
                cout << "not moving" << endl;
            else
            {
                int d = gcd(R[0],R[i]);
                cout << R[0]/d;
                if (R[i]>d)
                    cout << "/" << R[i]/d;
                cout << (moving[i]==1 ? " clockwise" : " counterclockwise") << endl;
            }
        }
    }
}
